#include <condefs.h>
#include <windows.h>
#pragma hdrstop
#include "AJBLisp.h"
//---------------------------------------------------------------------------
USEUNIT("Store.cpp");
USEUNIT("func.cpp");
USEUNIT("io.cpp");
USEUNIT("repl.cpp");
USEUNIT("Eval.cpp");
USEUNIT("Random.cpp");
//---------------------------------------------------------------------------
int LispHeapSize = 65536;
int StackSize = 16384;
int StringSize = 8192;
// Default source file is none
char* Source = "";

//extern "C" SetConsoleCtrlHandler(int(*Handler)(int), int);

int __stdcall ConsoleHandler(unsigned long type);

int main(int argc, char *argv[])
{
  int arg;
  for(arg = 1; arg < argc; arg++)
  {
    if(argv[arg][0] != '-') break;
    switch(argv[arg][1])
    {
      case 'h':  LispHeapSize = (atoi(&argv[arg][2]));
                 if(LispHeapSize < 4096)
                 {
                   printf("Heap to small or error in -h switch");
                   exit(0);
                 }
      break;
      case 's':  StackSize = (atoi(&argv[arg][2]));
                 if(StackSize < 1024)
                 {
                   printf("Stack to small or error in -s switch");
                   exit(0);
                 }
      break;
      case 'S':  StringSize = (atoi(&argv[arg][2]));
                 if(StringSize < 1024)
                 {
                   printf("String heap to small or error in -S switch");
                   exit(0);
                 }
      break;
      default:   printf("Unknown command line switch");
                 exit(0);
      break;
    }
  }

  // Startup banner
  printf(";;\n");
  printf(";; AJBLisp Version: V1.4 \n");
  printf(";;\n");
  printf(";; (c) A J Le Couteur Bisson 2000\n");
  printf(";;\n\n");

  // Allocate memory
  Stack(StackSize);                     // Allocate a stack
  Heap(LispHeapSize);                   // ...and some heap
  SHeap(StringSize);                    // ...and some string heap

  // Load the initialisation file if any
  LoadFile("init.lsp");

  // Load user supplied source file(s) if any
  for(; arg < argc; arg++)
    LoadFile(argv[arg]);

  SetConsoleCtrlHandler(ConsoleHandler, 1);

  // The main interpreter loop
  REPL();

  // Normal exit
  return 0;
}

// Handle Ctrl-C
int __stdcall ConsoleHandler(unsigned long type)
{
  if(type == CTRL_C_EVENT)
  {
    // Setting the user break flag interrupts Eval()
    UserBreak = true;
    return 1;
  }
  else
    return 0;
}
